angular.module('pageManagementService', ['ngResource']).

    factory('Page', function ($resource) {
        return $resource('/cms/page/:pageId', {pageId: '@pageId'})
    });

angular.module('paginationService', ['ngResource']).
    factory('Pagination', function () {
        return {
            initPagination : function($scope, dataCollection){
                $scope.totalItems = dataCollection.length;
                $scope.itemsPerPage = 50;
                $scope.currentPage = 0;
                $scope.numberOfPages = Math.ceil($scope.totalItems/$scope.itemsPerPage);
                this.groupToPages($scope, dataCollection)
            },
            prevPage : function ($scope) {
                if ($scope.currentPage > 0) {
                    $scope.currentPage--;
                }
            },

            nextPage : function ($scope) {
                if ($scope.currentPage < $scope.pagedItems.length - 1) {
                    $scope.currentPage++;
                }
            },

            setPage : function ($scope,pageNo) {
                $scope.currentPage = pageNo;
            },
            getPage : function ($scope) {
                return $scope.currentPage;
            },

            // calculate page in place
            groupToPages : function ($scope, dataCollection) {
                $scope.pagedItems = [];

                for (var i = 0; i < dataCollection.length; i++) {
                    if (i % $scope.itemsPerPage === 0) {
                        $scope.pagedItems[Math.floor(i / $scope.itemsPerPage)] = [ dataCollection[i] ];
                    } else {
                        $scope.pagedItems[Math.floor(i / $scope.itemsPerPage)].push(dataCollection[i]);
                    }
                }
            },

            pagesCount: function ($scope) {
                return $scope.numberOfPages
            }
        };
    });
