cmsApp.controller('ChangeUserPasswordController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    '$location',
    'userService',
    'errorService',
    'messageService',
    'loggingService',
    function UserDetailsController($scope, $http, $window, $rootScope, $location, userService, errorService, messageService, loggingService) {
        $window._testSupport = {
            isDocReady: function () {
                var phase = $rootScope.$root.$$phase;
                return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
            }
        };

        $scope.$parent.pageTitle = 'Change Password';

        $scope.onCancel = function () {
            $location.path("/");
        };

        $scope.onSave = function (){
            $scope.userDetail.userName = $rootScope.rootScopeCurrentUser.user;
            $http.put('/cms/user/changepassword/' + $scope.userDetail.userName, $scope.userDetail)
                .then(function(response){
                    if (response.data.changeUserPassword.invalidCredentials) {
                        clearFormData();
                        loggingService.info("cms-user-change-password-controllerJS","failed to change password. Invalid current password");
                        messageService.error("Invalid Credentials. Please enter correct details and try again");

                    } else {
                        loggingService.info("cms-user-change-password-controllerJS","user password changed successfully ");
                        messageService.info("Password is changed successfully.");
                        $location.path("/");
                    }
                }, errorService.errorHandler);
        }

        function clearFormData() {
            $scope.userDetail = {};
        }
    }]);
