cmsApp.controller('ChangeLogTableController', [
    '$scope',
    '$http',
    'errorService',
    'commonUtilService',
    'editorCommonService',
    function ChangeLogTableController($scope, $http, errorService,commonUtilService,editorCommonService) {
        $scope.history = {};
        $scope.revisionList = {};
        $scope.displayCompareAction = false;

        $scope.$emit('ChangeLogTableInit', function(displayCompareAction){
            $scope.displayCompareAction = displayCompareAction;
        });

        $scope.setHistory = function(history) {
            $scope.history = history;
        };

        $scope.getPage = function(pageNumber){
            $scope.$emit('pageChangeEvent', $scope.setHistory, pageNumber);
        };

        $scope.getListOfFiles = function(revisionId, isExpanding) {
            if (isExpanding) {
                loadRevisionFiles(revisionId);
            }
        };
        $scope.editModule = function (filePath) {
                editorCommonService.editModule('/'+filePath);
         };

        $scope.isEditable = function (file) {
            return commonUtilService.isCmsEditable(file);
         };

        function loadRevisionFiles(revisionId) {
            $http.get("/cms/git/loadrevisionfiles", {params: {revisionId: revisionId}}).then(function(response){
                $scope.revisionList[revisionId] = response.data.cmsLoadRevisionFiles.files;
            }, errorService.errorHandler);
        }

        $scope.getPage('1');
    }
]);