cmsApp.controller('EditSharedModuleController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    '$q',
    '$location',
    'errorService',
    'messageService',
    '$routeParams',
    'loggingService',
    'editorCommonService',
    function ($scope, $http, $window, $rootScope, $q, $location, errorService, messageService, $routeParams,loggingService, editorCommonService) {

        $window._testSupport = {
            isDocReady: function () {
                var phase = $rootScope.$root.$$phase;
                return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
            }
        };

        $scope.init = function(){
            var moduleFilePath = $routeParams.module;
            $scope.$parent.pageTitle = "Edit Shared Module";
            $scope.file = $routeParams.module;
            loggingService.info('cms-edit-sharedmodule-controllerJs','loading shared module editor for '+$scope.file);

            $q.all([
                    $http.get('/cms/sharedmoduleedit/ajax/currentsharedfile', {params: {moduleFilePath: moduleFilePath}}),
                    $http.get('/cms/sharedmoduleedit/ajax/availablesharedfiles', {params: {moduleFilePath: moduleFilePath} })
                ]).
                then(function (data) {
                    $scope.currentSharedModule = data[0].data.sharedModule.moduleName;
                    $scope.availableSharedModules = data[1].data.sharedModules.sharedModulesList;
                }, errorService.errorHandler);

        };

        $scope.saveSharedModule = function (moduleFilePath) {
            var deferred = $q.defer();
            saveModule(moduleFilePath, deferred.promise);
            deferred.resolve();
        };

        $scope.previewContent = function (moduleFilePath) {
            var deferred = $q.defer();
            var promise = deferred.promise;
            if($scope.sharedModuleForm.$dirty && $scope.sharedModuleForm.$valid) {
                saveModule(moduleFilePath, promise);
            }

            promise.then(function(result){
                editorCommonService.preview(moduleFilePath);
            });

            deferred.resolve();
        };

        $scope.close = function(){
            editorCommonService.close();
        };

        $scope.fileHistory = function () {
                    editorCommonService.showFileHistory($scope.file);
        };

        function saveModule(moduleFilePath, promise) {
            promise = promise.then(function(result){
                return $http.post('/cms/sharedmoduleedit/ajax/save', {moduleFilePath: moduleFilePath,sharedFilePath: $scope.currentSharedModule});
            });

            promise.then(function (result) {
                loggingService.info('cms-edit-sharedmodule-controllerJs', 'shared module saved ' + moduleFilePath );
                messageService.info("Saved Module Successfully.");
                $scope.sharedModuleForm.$setPristine();

            }, errorService.errorHandler);

            return promise;
        }
}]);
