cmsApp.controller('PageHistoryController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    '$location',
    'errorService',
    'commonUtilService',
    function PageHistoryController($scope, $http, $window, $rootScope, $location, errorService,commonUtilService) {

        $window._testSupport = {
            isDocReady : function() {
                var phase = $rootScope.$root.$$phase;
                return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
            }
        };


        $scope.$on('ChangeLogTableInit',function(event, callback){
            callback(commonUtilService.isModuleFile($scope.filePath) || commonUtilService.isFragment($scope.filePath));
        });

        $scope.$on('pageChangeEvent', function(event, callback, pageNumber) {
            $http.get("/cms/git/loadpagehistory", {params: {filePath: $scope.filePath, pageNum: pageNumber}})
                .then(function(response){
                    console.log(JSON.stringify(response));
                    callback(response.data.cmsChangeHistory)
                },function(response){console.log('ERRRR');errorService.errorHandler;} );
        });

        $scope.$parent.pageTitle = "File Change History";
        $scope.filePath =  $location.search().filePath;
        $scope.showCloseButton = true;

        $scope.close = function(){
           $location.path("/page-management");
        };
    }
]);

