cmsApp.controller('PageManagementController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    '$location',
    'errorService',
    'loggingService',
    'editorCommonService',
function ($scope, $http, $window, $rootScope,  $location, errorService,  loggingService,editorCommonService) {

    $scope.$parent.pageTitle = "Edit Pages";
    $scope.newPage = {};

    $window._testSupport = {
        isDocReady : function() {
            var phase = $rootScope.$root.$$phase;
            return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
        }
    };

    $scope.getTemplates = function () {
        var promise = pages();

        loggingService.info("cms-pagemanagement-controllerJS","getting Templates");
        promise.then(function(){
            $http.get('/cms/template').then(function (response) {
                $scope.templates = response.data.getTemplates.templates;
                $scope.newPage.application="/www";
                loggingService.info("cms-pagemanagement-controllerJS","got Templates");
            }, errorService.errorHandler);
        }, errorService.errorHandler);
    };

    $scope.addPage = function () {
        $scope.newPage.location=$scope.newPage.application+$scope.newPage.location
        $http.post('/cms/ajax/addpage', $scope.newPage).then(function (response) {
            $location.path("/page-management");
            loggingService.info("cms-pagemanagement-controllerJS", "added page " +$scope.newPage.location);
        }, errorService.errorHandler);
    };

    $scope.cancelAddPage = function () {
        $location.path("/page-management");
    };

    $scope.getListOfPages = function (templateName) {
        return $scope.templatePageListMap[templateName];
    };

    $scope.preview = function (fileName) {
      editorCommonService.preview(fileName);
    };

    function pages() {
        loggingService.info("cms-pagemanagement-controllerJS","getting pages");
        var promise = $http.get('/cms/ajax/pagelocations');
        promise = promise.then(function(response){
            $scope.templatePageListMap = response.data.templatePagesListMap;
            $scope.existingPageLocations= response.data.cmsPageLocations.pageLocations;
            loggingService.info("cms-pagemanagement-controllerJS","got pages");
        },errorService.errorHandler);

        return promise;
    }
}]);