cmsApp.controller('SearchController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    'Pagination',
    'errorService',
    '$location',
    '$routeParams',
    'editorCommonService',
    function SearchController($scope, $http, $window, $rootScope, Pagination, errorService, $location, $routeParams, editorCommonService){

        $scope.$parent.pageTitle = "Find content in files";
        $window._testSupport = {
            isDocReady : function() {
                var phase = $rootScope.$root.$$phase;
                return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
            }
        };

        if ($routeParams.search){
            $scope.searchRequest = $routeParams.search;



            $scope.searchResultsCount = 0;
            $http.post('/cms/search', {keyword: $routeParams.search}).then(function(response){
                Pagination.initPagination($scope, response.data.search.files);
                if ($routeParams.page){
                    Pagination.setPage($scope, $routeParams.page);
                }
                $scope.searchResultsCount = response.data.search.files.length;
                $scope.searchResultKeyword = response.data.search.keyword;
                $scope.searchResults = true;
            }, errorService.errorHandler);
        }

        $scope.searchContents= function(searchRequest){
            $location.search('search', searchRequest);
        };

        $scope.loadEditor = function(file){
            var path = 'cms#/edit?fragment='+file;

            var match = /[#](.*)[?](.*)=(.*)/.exec(path);

            var pageNo = Pagination.getPage($scope);

            editorCommonService.closeCallback = function(){
                $location.search({search: $routeParams.search, page: pageNo}).path("/search")
            };

            $location.search(match[2], match[3]).path(match[1]);

        }

        $scope.prevPage = function () {
            Pagination.prevPage($scope)
        };

        $scope.nextPage = function () {
            Pagination.nextPage($scope)
        };

        $scope.pagesCount = function () {
            Pagination.pagesCount($scope)
        };
    }]);

