cmsApp.controller('SuspendPublishController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    '$location',
    'errorService',
    'messageService',
    'loggingService',
    'userService',
    'dateService',
    function SuspendPublishController($scope, $http, $window, $rootScope, $location, errorService, messageService, loggingService, userService,dateService) {
        $scope.$parent.pageTitle = "Suspend publish to live";

        $window._testSupport = {
            isDocReady: function () {
                var phase = $rootScope.$root.$$phase;
                return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
            }
        };

        if (!userService.getUserData().hasRole('SYSTEM_ADMIN')) {
            messageService.error("You are not authorised to perform Suspend Publish operation.");
            $location.path("/");
        }

        loggingService.info("cms-suspend-publishing-controllerJS","getting current publishing state ");
        $http.get('/cms/sysadmin/publishingstate')
            .then(function(response){
                loggingService.info("cms-suspend-publishing-controllerJS","current publishing state is " +response.data.publishState.status);
                if (response.data.publishState.status == "SUSPENDED") {
                    $scope.suspended = "true";
                    $scope.suspensionMessage = response.data.publishState.message;
                } else if (response.data.publishState.status == "PUBLISHING") {
                    $scope.publishInProgress=true;
                    $scope.publishState=response.data.publishState;
                } else {
                    $scope.suspended = "false";
                }

            }, errorService.errorHandler);


        $scope.changePublishState = function() {
            var publishState = $scope.suspended=="true" ?"SUSPENDED":"READY";
           $http.post('/cms/sysadmin/publishingstate', {status: publishState, message: $scope.suspensionMessage})
                .then(function (response) {
                    console.log('.........response........'+response);
                    loggingService.info("cms-suspend-publishing-controllerJS","updated publishing state to "+publishState);
                    messageService.info("Successfully changed the publishing state.");
                }, errorService.errorHandler);
        };

        $scope.getDuration=function(startDateTime,endDateTime){
            var startDate = new Date(startDateTime);
            var endDate = new Date(endDateTime);
            if ($scope.publishState) {
                return dateService.getDiffInMinAndSec(startDate,endDate);
            }
            return 0;
        }
    }]);
