cmsApp.controller('ManageWorkspaceController', [
    '$scope',
    '$http',
    '$window',
    '$rootScope',
    '$cookies',
    '$q',
    '$location',
    '$routeParams',
    'errorService',
    'messageService',
    'gitService',
    'dbService',
    'loggingService',
    'conflictService',
    'editorCommonService',
    'commonUtilService',
    'scssService',
    function ($scope, $http, $window, $rootScope, $cookies, $q, $location, $routeParams, errorService, messageService,
    gitService, dbService, loggingService, conflictService, editorCommonService,commonUtilService,scssService) {

        $window._testSupport = {
            isDocReady: function () {
                var phase = $rootScope.$root.$$phase;
                return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
            }
        };

        var currentTab;
        if ($routeParams.tab) {
            currentTab = $routeParams.tab;
        } else if ($scope.$root.rootScopeCurrentBranch == 'master') {
            currentTab = 'changeWorkspaceTab';
        } else {
            currentTab = 'currentWorkSpaceTab';
        }

        $scope.$parent.pageTitle = "Manage Branches";
        var mergedBranches;

        $scope.newBranch = {};
        $scope.showOthersWorkspace = true; // This variable will set the collapsible pane on the select workspace to expanded.
        $scope.showMyWorkspace = true;  // Likewise.
        getPage(1);
       /* dbService.mergedBranches(function(result){
            mergedBranches = result.data.dbMergedBranches.branches;
            $scope.pageTotal = Math.ceil(mergedBranches.length / 20);
            $scope.pageNum = 1;

            $scope.mergedBranches = mergedBranches.slice( ($scope.pageNum - 1) * 20, $scope.pageNum * 20 );
        });*/

        loadBranchInfo(function(branchDetails, currentBranchName){
            $scope.branchDetails = branchDetails;
            $scope.$root.rootScopeCurrentBranch = currentBranchName;
            $scope.currentWorkspace = findCurrentWorkspace(branchDetails, currentBranchName)
        });

        $scope.onChangeTab = function(tab){
            currentTab = tab;
            $scope.newBranch = {};
        };

        $scope.onCreateNewBranch = function () {
        $scope.createBranchInProgress=true;
         var flow = gitService.setErrorMessage("Branch checkout failed.")
                    .status()
                    .then(function (result, control) {
                        if (!result.data.gitStatus.clean) {
                            messageService.error("You have pending changes which must be saved before creating new branch.");
                            control.reject();
                        } else {
                            $http.post('/cms/git/createbranch', $scope.newBranch).then(function (response) {
                                $scope.newBranch.createdBy = $rootScope.rootScopeCurrentUser.user;
                                dbService.createBranch($scope.newBranch, createBranchSuccessHandler, errorService.errorHandler);
                                $scope.createBranchInProgress=false;
                            }, errorService.errorHandler);
                        }
                     });
        };

        $scope.onCheckoutBranch = function (selectedBranch) {
            startBranchCheckout(selectedBranch);
            loggingService.info("cms-workspace-controllerJS", "checkout branch " + selectedBranch);
        };

        $scope.onEditFile= function (filePath) {
            editorCommonService.editModule("/"+filePath);
        };

        $scope.canPreview= function (filePath) {
            return commonUtilService.canBePreviewed(filePath);
        };

        $scope.changeGlyphiconClass = function (isExpanded) {
            if (isExpanded) {
                return "glyphicon-minus";
            } else {
                return  "glyphicon-plus";
            }
        };

        $scope.classesIfCurrentlyActive = function (tab) {
            return tab == currentTab ? "active in" : "";
        };

        $scope.onPreviousPage = function(){

            if ($scope.pageNum > 1){
                $scope.pageNum = $scope.pageNum - 1;
            }
                getPage($scope.pageNum);
            //$scope.mergedBranches = mergedBranches.slice( ($scope.pageNum - 1) * 20, $scope.pageNum * 20 );
        };
        $scope.onNextPage = function(){

            if ($scope.pageNum < $scope.pageTotal){
                $scope.pageNum = $scope.pageNum + 1;
            }
                getPage($scope.pageNum);
            //$scope.mergedBranches = mergedBranches.slice( ($scope.pageNum - 1) * 20, $scope.pageNum * 20 );
        };

          function getPage(pageNumber){
                  dbService.mergedBranches(pageNumber,20,function(result){
                                mergedBranches = result.data.dbMergedBranches.branches;
                                $scope.pageTotal = result.data.totalPages;
                                $scope.pageNum = pageNumber;
                                $scope.mergedBranches = mergedBranches;
                        });
         };


        function loadBranchInfo(callback) {
            function splitWorkspaces(data) {
                var branchList = data.branches;
                var currentBranch = data.currentBranch;
                var myWorkspace = [];
                var othersWorkspace = [];
                var currentWorkspace;
                angular.forEach(branchList, function (branch) {
                    if (branch.contributors && branch.contributors.indexOf($rootScope.rootScopeCurrentUser.user) != -1) {
                        myWorkspace.push(branch);
                    } else {
                        othersWorkspace.push(branch);
                    }
                });

                return { myWorkspace: myWorkspace, othersWorkspace: othersWorkspace}
            }

            gitService.fetch().then(function (result) {

                $http.get('/cms/git/loadbranches').then(function (response) {
                    var currentBranchName = response.data.cmsLoadBranches.currentBranch;
                    callback(splitWorkspaces(response.data.cmsLoadBranches), currentBranchName);

                }, errorService.errorHandler)


            }, errorService.errorHandler)
        }

        function findCurrentWorkspace(branchDetails, currentBranchName){
            var result = null;
            angular.forEach(branchDetails, function (branches, branchType) {
                angular.forEach(branches, function (branch) {
                    if (branch.branchName == currentBranchName) {
                        result = branch;
                    }
                });
            });
            return result;
        }

        function createBranchSuccessHandler(result) {
            if (result.data.createBranch) {
                loadBranchInfo(function(branchDetails, currentBranchName){
                    $scope.branchDetails = branchDetails;
                    $scope.$root.rootScopeCurrentBranch = currentBranchName;
                    $scope.currentWorkspace = findCurrentWorkspace(branchDetails, currentBranchName)
                });
                loggingService.info("cms-workspace-controllerJS", "created new branch " + JSON.stringify($scope.newBranch));
                messageService.info("Created branch " + $scope.newBranch.branchName);
                currentTab = 'currentWorkSpaceTab';
            } else {
                messageService.error("Failed to create new branch in DB");
            }
        }

        function startBranchCheckout(branchName) {

            var flow = gitService
                .setErrorMessage("Branch checkout failed.")
                .status()
                .then(function (result, control) {
                    if (!result.data.gitStatus.clean) {
                        messageService.error("You have pending changes which must be saved before changing branch.");
                        control.reject();
                    } else {
                        control.accept();
                    }
                })
                .checkoutBranch(branchName)
                .pull()
                .then(function (result, control) {
                    if (result.data.gitConflict) {

                        conflictService.handleConflict(result.data.gitConflict,
                            "Conflict while merging branch changes.",
                            branchName,
                            "remotes/origin/" + branchName,
                            function () {
                                commenceMasterMerge(gitService.flow().setErrorMessage("Continuing branch checkout after merging with remote branch failed."));
                            });

                        control.reject();
                    } else {
                        scssService.onPullRegenerateScss(
                            result,
                            function () {
                                control.accept()
                            },
                            function (error) {
                                control.reject();
                                errorService.errorHandler(regScssRes.error);
                            });
                    }
                });

            commenceMasterMerge(flow);
        }

        function commenceMasterMerge(flow) {
            var branchName = gitService.reference();
            flow
                .currentBranch()
                .then(function (result, control) {
                    branchName.value = result.data.gitCurrentBranch.name;
                    control.accept();
                })
                .merge('remotes/origin/master')
                .then(function (result, control) {
                    loggingService.info("cms-workspace-controllerJS", "updated branch " + branchName.value + " from master ");
                    if (result.data.gitConflict) {
                        conflictService.handleConflict(result.data.gitConflict,
                            "Conflict while merging changes from production.",
                            branchName.value,
                            "remotes/origin/master",
                            function () {
                                finish(gitService.flow().setErrorMessage("Continuing branch checkout after merging with remote master failed."));
                            });
                        control.reject();
                    } else {
                        control.accept();
                    }
                });

            finish(flow);
        }

        function finish(flow) {
            flow
                .currentBranch()
                .then(function (result, control) {
                    var branchName = result.data.gitCurrentBranch.name;
                    $scope.currentWorkspace = findCurrentWorkspace($scope.branchDetails, branchName);
                    $scope.$root.rootScopeCurrentBranch = branchName;
                    messageService.info("Switched to branch " + branchName);
                    $location.path("/managebranch-display/changeWorkspaceTab");
                    control.accept();
                });
        }

    }]);