cmsApp.controller('WysiwygEditController', [
    '$filter',
    '$scope',
    '$http',
    '$window',
    '$location',
    '$rootScope',
    '$q',
    '$routeParams',
    'errorService',
    'messageService',
    'gitService',
    'loggingService',
    'editorCommonService',
    'ckEditorCommonService',
function ($filter, $scope, $http, $window, $location, $rootScope, $q, $routeParams, errorService, messageService, gitService, loggingService, editorCommonService, ckEditorCommonService) {
    $window._testSupport = {
        isDocReady : function() {
            var phase = $rootScope.$root.$$phase;
            return $http.pendingRequests.length == 0 && phase != '$apply' && phase != '$digest';
        }
    };

    init();

    function init(){
        if ($rootScope.rootScopeCurrentBranch == 'master'){
            messageService.error("Editing files on master is prohibited.  Please create a branch.");
            $location.path("/");
            return;
        }
        $scope.editor = WYSIWYG_EDITOR;
        messageService.cleanupOldMessages();
        $scope.$parent.pageTitle = "Edit Page";

        var file = $routeParams.fragment;
        $scope.file = file;
        var matches = /(.*)\/(.*?)$/.exec(file);
        $scope.filePath = matches[1];
        $scope.fileName = matches[2];
        initializeWysiWygEditor(file);
    }

    $scope.saveContent = function () {
        if (CKEDITOR.instances.ckEditor.checkDirty()) {
            var content = CKEDITOR.instances.ckEditor.getData();
            $http.post("/cms/edit/fragment", {content: content, fragmentPath: $scope.file})
                .then(function (result) {
                    messageService.info("Fragment saved. " + $filter('date')(result.data.saveFragment.savedDate.millis, "medium"));
                    loggingService.info('cms-wysiwyg-editor-controllerJs', 'Saved fragment ' + $scope.file );
                }, errorService.errorHandler);
        } else {
            messageService.error("Nothing to save.");
        }
    };

    $scope.fileHistory = function () {
        editorCommonService.showFileHistory($scope.file);
    };

    $scope.previewContent = function () {
        editorCommonService.preview($scope.filePath.substring(0,$scope.filePath.lastIndexOf("/")));
    };

    $scope.close = function(){
        editorCommonService.close(WYSIWYG_EDITOR);
    };

    function initializeWysiWygEditor(file){
        var editorServicePromise = ckEditorCommonService.ckEditorConfig(file);

        editorServicePromise.then(function(result) {
             return $http.get("/cms/edit/fragment", {params: {fragment: file}});
        }, errorService.errorHandler)
        .then(function(result) {
            $scope.fragmentContents = result.data.getFragment.content;
            CKEDITOR.replace('ckEditor', ckEditorCommonService.editorConfig);
            loggingService.info("cms-wysiwyg-editor-controllerJs", "loading WYSIWYG editor for "+file);
        }, errorService.errorHandler);
    }
}]);