cmsApp.factory("ckEditorCommonService", function ($q, $http, errorService, loggingService) {
    return {
        editorConfig : null,
        cssContent : null,
        parseCSS : function (indexPageSource) {
            function matchedGroups(pattern, sourceStr) {
                var groups = [];
                while (pattern.test(sourceStr)) {
                    var matched = pattern.exec(sourceStr);
                    groups.push(matched[1]);
                    sourceStr = sourceStr.replace(matched[0], " ");
                }
                return groups;
            }

            var cssRegEx = /<link.*href[\s]*=[\s]*["'](\S*\.css)\??.*?["'].*[</link>|/>]/i;
            return matchedGroups(cssRegEx, indexPageSource);
        },
        ckEditorConfig : function(fragmentFilePath) {
            var self = this;
            var parseCSS = this.parseCSS;
            var matches = /(.*)\/(.*?)$/.exec(fragmentFilePath);
            var filePath = matches[1];

            var promise =  $http.get('/cms/edit/fragment/indexpagepath', {params: {fragment: filePath}});

            promise = promise.then(function (indexPagePathResponse) {
                   var parentDeferred = $q.defer();
                   parentDeferred.reject(errorService.error("ERROR_CMS_NO_INDEX_PAGE", "no index page found for this fragment"));
                }, errorService.errorHandler)
//                promise = promise.then(function (indexPagePathResponse) {
//                   if (indexPagePathResponse.data.indexPagePath.path != null) {
//                       return $http.get("/"+indexPagePathResponse.data.indexPagePath.path);
//                   } else {
//                       var parentDeferred = $q.defer();
//                       parentDeferred.reject(errorService.error("ERROR_CMS_NO_INDEX_PAGE", "no index page found for this fragment"));
//                   }
//                }, errorService.errorHandler)
               .then(function(result) {
                    self.cssContent = [];
                    self.cssContent.push('_assets/css/cms.css');
                    return $http.get("user/currentuser");
               }, errorService.errorHandler)
               .then(function(result) {
                    var deferred = $q.defer();

                    var user = result.data.currentUser;

                    self.editorConfig = {
                       contentsCss: self.cssContent,
                       enterMode: CKEDITOR.ENTER_BR,
                       forcePasteAsPlainText: false, // default so content won't be manipulated on load
                       basicEntities: false,
                       entities: true,
                       entities_latin: false,
                       entities_greek: false,
                       entities_processNumerical: false,
                       fillEmptyBlocks: function (element) {
                           return true; // DON'T DO ANYTHING!!!!!
                       },
                       filebrowserBrowseUrl: '/CKFinderJava/ckfinder/ckfinder.html',
                       filebrowserImageBrowseUrl: '/CKFinderJava/ckfinder/ckfinder.html?type=Images',
                       filebrowserUploadUrl: '/CKFinderJava/ckfinder/core/connector/java/connector.java?command=QuickUpload&type=Files',
                       filebrowserImageUploadUrl: '/CKFinderJava/ckfinder/core/connector/java/connector.java?command=QuickUpload&type=Images',
                       filebrowserFlashUploadUrl: '/CKFinderJava/ckfinder/core/connector/java/connector.java?command=QuickUpload&type=Flash',
                       allowedContent: true,
                       height: 500,
                       bodyClass:'ckEditor_scrollbar',
                       extraPlugins: 'cms-toggle-style,div',
                       removeButtons: function(){
                           if (user.roles.indexOf("SOURCE_EDITOR") < 0) {
                               return 'Source';
                           }
                           return ''
                       }(),
                       coreStyles_bold: { element: 'b', overrides: 'strong' }
                   };

                   loggingService.info("cms-ckeditor-common-service", "created ckEditor config for fragment "+fragmentFilePath);

                   deferred.resolve(result);

                   return deferred.promise;
               }, errorService.errorHandler);

            return promise;
       }
    }
});