cmsApp.factory("commonUtilService", function () {
    return {
        endsWith : function(f, value){
            return f.indexOf(value) != -1 && (f.indexOf(value) == f.length - value.length);
        },

        isControlFile:function(file){
                return  this.endsWith(file, 'index.page.vm') ||
                        this.endsWith(file, 'index.highend.page.vm') ||
                        this.endsWith(file, 'index.lowend.page.vm');
        },

        isScssFile:function(file){
            return this.endsWith(file, '.scss');
        },

        isCssFile:function(file){
            return this.endsWith(file, '.css');
        },

        isModuleFile:function(file){
            return this.endsWith(file, '.module.vm');
        },
        isSharedModuleFile:function(file){
            return this.endsWith(file, '.shared.vm');
        },
        isFragment:function(file){
            return this.endsWith(file, '.cms.vm');
        },
        isVelocityFile:function(file){
            return this.endsWith(file, '.vm');
        },
        isCmsEditable:function(file){
            return this.isModuleFile(file) || this.isFragment(file) || this.isSharedModuleFile(file);
        },
        canBePreviewed:function(file){
            return this.isVelocityFile(file);
        },

        getModuleFiles:function(files){
            var modulesFiles = [];
            for(var i in files){
                if(this.isModuleFile(files[i])){
                    modulesFiles.push(files[i])
                }
            }
            return modulesFiles;
        },
        findMatchingGroups:function(sourceContent,patternToMatch) {
            var groups = [];
            while (patternToMatch.test(sourceContent)) {
                var matched = patternToMatch.exec(sourceContent);
                groups.push(matched[1]);
                sourceContent = sourceContent.replace(matched[0], " ");
            }
            return groups;
        },
        replaceMatchingContent:function(sourceContent,patternToMatch,replaceBy) {
            var groupsToReplace = this.findMatchingGroups(sourceContent,patternToMatch);
            if (groupsToReplace.length == 0) {
                return sourceContent;
            }
            for (i=0;i<groupsToReplace.length;i++) {
                sourceContent = sourceContent.replace(groupsToReplace[i],replaceBy);
            }
            return sourceContent;
        }
    }
});
