cmsApp.factory("dateService", function ($http) {
    return {
        timeNow : function () {
                return new Date().getTime();
        },
        now : function () {
            return new Date();
        },
        toUTCDate : function (date) {
            return new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(),  date.getUTCHours(), date.getUTCMinutes(), date.getUTCSeconds());
        },
        getDiffInMillSec: function(startDate,endDate) {
            if(!startDate) {
                return -1;
            }

            if (!endDate) {
                  endDate = this.now();
            }

            startDate = new Date(startDate);
            startDate = new Date(startDate.getFullYear(), startDate.getMonth(), startDate.getDay(), startDate.getHours(), startDate.getMinutes(), startDate.getSeconds(), 0);

            endDate = new Date(endDate);
            endDate = new Date(endDate.getFullYear(), endDate.getMonth(), endDate.getDay(), endDate.getHours(), endDate.getMinutes(), endDate.getSeconds(), 0);

            return endDate - startDate;
        },
        getDurationInMinutes: function(startDate,endDate) {
            var diff = this.getDiffInMillSec(startDate, endDate)
            if(diff == -1) {
                return -1;
            }

            return (diff/(1000 * 60)).toFixed(2);
        },
        getDiffInMinAndSec: function(startDate,endDate) {
            if (!endDate) {
               endDate = this.now();
            }
            var totalMillSec = this.getDiffInMillSec(startDate, endDate)
            if(totalMillSec == -1) {
                return -1;
            }

            var totalSec = totalMillSec/1000;
            var totalMin = Math.floor(totalSec/60);
            var sec = Math.floor(totalSec%60);

            return totalMin+" min "+sec+" sec";
        },
        getCurrentTimeStamp:function() {
          var now = this.now();
          return this.pad(now.getFullYear())
                +this.pad(now.getMonth()+1)
                + this.pad(now.getDate())
                + this.pad(now.getHours())
                + this.pad(now.getMinutes())
                + this.pad(now.getSeconds());
        },
        pad:function(n) {
            return n<10 ? '0'+n : n;
        }

    };
});
