cmsApp.factory("dbService", function ($http, errorService) {

    function Utils() {
    }

    Utils.resolveErrorHandler = function (errorCallback, message) {
        var messageHandlingErrorHandler = function (result) {
            return errorService.errorHandler(result, message);
        };

        return errorCallback == undefined ? messageHandlingErrorHandler : errorCallback;
    };

    return {

        createBranch: function (newBranch, successCallback, errorCallback) {
            return $http.post('/cms/ajax/db/atomic/createbranch', newBranch)
                .then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        addContributor: function (branch, contributor, successCallback, errorCallback) {
            return $http.post('/cms/ajax/db/atomic/addcontributor/' + branch, contributor)
                .then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        commit: function (branch, changedFiles, successCallback, errorCallback) {
            return $http.post('/cms/ajax/db/atomic/commit/' + branch, changedFiles)
                .then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        mergedBranchesSinceLastPushToLive: function (mostRecentPushTOLiveDate, successCallback, errorCallback) {
            return $http.get('/cms/ajax/db/atomic/mergedbranchdetails', {params: {mergedAfterDate: mostRecentPushTOLiveDate}})
                .then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        mostRecentPushToLive: function (successCallback, errorCallback) {
            return $http.get('/cms/ajax/db/atomic/pushtolive').then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        pushToLiveHistory: function (pgNum, pgSize, successCallback, errorCallback) {
            return $http.get('/cms/ajax/db/atomic/pushtolive/history', {params : {pageNum : pgNum, pageSize : pgSize}}).then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        savePushToLiveDetails: function (userName, headRef, startTime, branches, successCallback, errorCallback) {
            return $http.post('/cms/ajax/db/atomic/pushtolive', {userName: userName,  headRef: headRef, startTime: startTime, branches: branches})
                .then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        mergedBranches: function (pgNum, pgSize,successCallback, errorCallback) {
            return $http.get('/cms/ajax/db/atomic/mergedbranches',{params : {pageNum : pgNum, pageSize : pgSize}}).then(successCallback, Utils.resolveErrorHandler(errorCallback));
        },

        publishState: function (successCallback, errorCallback) {
            return $http.get('/cms/sysadmin/publishingstate').then(successCallback, Utils.resolveErrorHandler(errorCallback));
        }


    }

});
