cmsApp.factory("editorCommonService", function ($http, $rootScope, $window, $location, $q,commonUtilService,fsService,errorService,messageService, loggingService) {
    return {
        truncatedFilePathForPreview : function(filePath){
            if (commonUtilService.isControlFile(filePath)) {
                if (filePath.indexOf('/') != 0) {
                    filePath = "/"+filePath;
                }
                return truncatedFilePath = filePath.substring(0,filePath.indexOf("index."));
            } else if(commonUtilService.canBePreviewed(filePath)) {
                var truncatedFilePath = filePath;
                var deviceCategory = this.deviceCategoryForFile(filePath);
                if (deviceCategory != null) {
                    return truncatedFilePath = filePath.substring(0, filePath.indexOf(deviceCategory + DEVICE_CAT_FOLDER_NAME_APPENDER));
                }
            }

            return filePath;
        },
        getModuleName : function(filePath){

            return filePath.substring(filePath.lastIndexOf('/') + 1);
        },
        deviceCategoryForFile : function(filePath){
            var truncatedFilePath = filePath;
            for (var i = 0; i < DEVICE_CATEGORIES.length; i++) {
                if (filePath.indexOf(DEVICE_CATEGORIES[i] + DEVICE_CAT_FOLDER_NAME_APPENDER) != -1) {
                    return DEVICE_CATEGORIES[i];
                }
            }
            return null;
        },
        editorType : function(file){
            if (file.match("[.]cms[.]vm$")){
                return WYSIWYG_EDITOR;
            } else if(file.match("[.]module[.]vm$")) {
                return MODULE_EDITOR;
            } else if(file.match("[.]shared[.]vm$")){
                return SHARED_MODULE_EDITOR;
            } else {
                return null;
            }
        },
        closeCallback: function(){
            $location.path("/page-management");
        },
        close: function (editor) {
            if(editor && WYSIWYG_EDITOR == editor) {
                $location.search("fragment",null);
            } else {
                $location.search("module", null);
            }
            this.closeCallback();

            //The close callback can be replaced to support context specific callbacks.
            //Just prior to loading the editor, the closeCallback is replaced.
            //Problem is that editing is sometimes initiated by ckEditor.  It doesn't setup callbacks.
            //So our default close handler is supporting ckEditor.
            this.closeCallback = function(){
                $location.path("/page-management");
            }

        },

        preview:function(filePath){
            if (filePath.indexOf("/") != 0) {
                filePath = "/"+filePath;
            }
            if (filePath.indexOf("/www")!= 0) {
                filePath = "/www"+filePath;
            }
            if(filePath.indexOf(".jpg") != -1 || filePath.indexOf(".jpeg") != -1 || filePath.indexOf(".gif") != -1) {
                window.open("http://" + window.location.hostname + ":" + window.location.port +filePath, "PreviewWindow");
            } else {
                window.open("http://" + window.location.hostname + ":" + window.location.port +this.truncatedFilePathForPreview(filePath), "PreviewWindow");
            }
        },

        editModule : function(filePath) {
            var self = this;
            var editorType = this.editorType(filePath);
            fsService.fileExists(filePath,function(result){
                if(result.data.fsFileExists.fileExists==true) {
                        if(WYSIWYG_EDITOR == editorType) {
                            $location.search("fragment",filePath).path("/wysiwyg-edit");
                        } else if(MODULE_EDITOR == editorType){
                            $location.search("module", filePath).path("/module-edit");
                        } else if(SHARED_MODULE_EDITOR == editorType) {
                            $location.search("module", filePath).path("/shared-module-edit");
                        } else {
                            self.preview(filePath);
                        }
                } else {
                    messageService.error("File '"+filePath+ "' does not exists.");
                }
             },errorService.errorHandler);
        },

        showFileHistory : function(filePath) {
            if(filePath.indexOf('/')==0){
                filePath = filePath.substring(1,filePath.length);
            }
            $location.search('filePath',filePath).path('/page-history');
        }

    }
});
