
cmsApp.factory("jsonEditorService", function($rootScope, $location, $q){

        function addSchemaAttributesToJsonDoc(dataJson, schema) {
            var result = {};
            var json = dataJson== undefined?createObjectFromSchema(schema):dataJson;
            var properties = schema.properties;

            for (var propertyName in properties) {
                var property = properties[propertyName];
                var jsonForProperty = isEmpty(json[propertyName])?createObjectFromSchema(property):json[propertyName];
                if (property.uitype == 'panel') {
                    result[propertyName] = addSchemaAttributesToJsonDoc(jsonForProperty, property);
                } else if(property.uitype == 'panels') {
                        var arrJson = [];
                        for (var listItemIndex in json[propertyName]) {
                            arrJson.push(addSchemaAttributesToJsonDoc(json[propertyName][listItemIndex], property.items));
                            Object.defineProperty(arrJson[listItemIndex], 'meta', {value: angular.copy(property.items)});
                        }
                    result[propertyName] = arrJson;
                } else {
                    result[propertyName] = {value: json != undefined ? json[propertyName] : ""};
                }

                Object.defineProperty(result[propertyName], 'meta', {value: angular.copy(property)});
            }
            return result;
        }

        function removeSchemaAttributesFromJsonDoc(jsonObj, newJson) {
            if(newJson == undefined) newJson = {};
            for (var currentProperty in jsonObj) {
                if (currentProperty == "$$hashKey") {
                    continue;
                }
                var uitype = jsonObj[currentProperty].meta.uitype;

                if (uitype == 'panel') {
                    newJson[currentProperty] = removeSchemaAttributesFromJsonDoc(jsonObj[currentProperty]);
                }else if (uitype == 'panels') {
                    var jsonArray = [];
                    for (var i in jsonObj[currentProperty]) {
                        if (i == "$$hashKey") {
                            continue;
                        }
                        jsonArray.push(removeSchemaAttributesFromJsonDoc(jsonObj[currentProperty][i]));
                    }
                    newJson[currentProperty] = jsonArray;

                } else {
                    if (jsonObj[currentProperty].value != null) {
                        newJson[currentProperty] = jsonObj[currentProperty].value
                    }
                }
            }

            return newJson;
        }


        function addItem(array){
            var aryItem = createObjectFromSchema(array.meta.items);
            var newItem = addSchemaAttributesToJsonDoc(aryItem, array.meta.items);
            Object.defineProperty(newItem, 'meta', {value: angular.copy(array.meta.items)});
            array.push(newItem);
        }

       function removeItem(array, index){
            array.splice(index, 1);
       }

        function moveUp(array, index){
            if (index != 0) {
                var tmp = array[index];
                array[index] = array[index - 1];
                array[index - 1] = tmp;
            }
        }

        function moveDown(array, index){
            if (index != array.length -1) {
                var tmp = array[index];
                array[index] = array[index + 1];
                array[index + 1] = tmp;
            }
        }

        function createObjectFromSchema(element){
            var jsonToReturn = null;
            var uitype = element.uitype;
            switch (uitype){
                case "panels":{
                    jsonToReturn = jsonToReturn != undefined ? jsonToReturn: [];
                    jsonToReturn.push(createObjectFromSchema(element.items)) ;
                    break;
                }
                case "panel":{
                    jsonToReturn = jsonToReturn != undefined ? jsonToReturn: {};
                    for(key in element.properties)
                        jsonToReturn[key] = createObjectFromSchema(element.properties[key])
                    break;
                }
                default:
                    jsonToReturn = ''
            }
            return jsonToReturn;
        }

        function isEmpty(dataJson) {
            if(dataJson==undefined || dataJson == null){
                return true;
            }

            if(dataJson == {} || dataJson == [] || dataJson == ''){
                return true;
            }
        }
        function clearValue(jsonLeafObj){
            jsonLeafObj.value="";
        }

        return {
                addItem: addItem,
                removeItem: removeItem,
                moveUp: moveUp,
                moveDown: moveDown,
                clearValue: clearValue,
                addSchemaAttributesToJsonDoc: addSchemaAttributesToJsonDoc,
                removeSchemaAttributesFromJsonDoc: removeSchemaAttributesFromJsonDoc
            };
    });