
cmsApp.factory("messageService", function($rootScope, $location, $q){

        return {
                messages: [],
                error: function(message) {
                    this.messages.push({date: new Date(), message: message, severity: 'ERROR'});
                    this.cleanupOldMessages();
                },
                info: function(message) {
                    this.messages.push({date: new Date(), message: message, severity: 'INFO'});
                    this.cleanupOldMessages();
                },
                cleanupOldMessages: function(){
                     //we need the timed messages concept for when the user directly enter urls into the address bar.
                     var keepMessages = [];
                     for(var i = 0; i < this.messages.length; i++){
                        if (new Date().getTime() - this.messages[i].date.getTime() < 500 ){
                            keepMessages.push(this.messages[i]);
                        }
                     }
                    this.messages.length = 0;

                    angular.copy(keepMessages,this.messages);
                }
            };
    });

cmsApp.directive('href', function(){
        return {
            controller: function($scope, $element, messageService){
                $element.bind('click', function() {
                    messageService.cleanupOldMessages();
                });
            }
        };
    });

cmsApp.directive('ngClick', function(){
        return {
            controller: function($scope, $element, messageService){
                $element.bind('click', function() {
                    messageService.cleanupOldMessages();
                });
            }
        };
    });