cmsApp.factory("scssService", function($http,commonUtilService,loggingService){

    return {
            regenerateScssWithGrunt : function(moduleFiles, successCallback, errorCallback){
                           return $http.post('/cms/moduleedit/ajax/regeneratescsswithgrunt', moduleFiles).then(successCallback, errorCallback);
            },

            onPullRegenerateScss : function(pullResult, successCallback, errorCallback) {
                var gitFilesChanged = _.filter(pullResult.data.gitPull.changedFiles, function(gitFile){if(gitFile.action!='DELETE') return gitFile.fileName});
                var changedFilesNames = _.map(gitFilesChanged, function(gitFile){return gitFile.fileName})
                var moduleFiles = commonUtilService.getModuleFiles(changedFilesNames);
                 if(moduleFiles.length > 0  ){
                     loggingService.info('cms-scss-serviceJs',"Regenerating scss for files " + moduleFiles);
                     this.regenerateScssWithGrunt(moduleFiles,
                            successCallback,
                            errorCallback);

                 }else{
                    successCallback();
                 }

            },
            runGrunt : function(applicationCtx, successCallback, errorCallback){
                return $http.get('/cms/ajax/grunt/atomic/run', {params: {applicationContext: applicationCtx}}).then(successCallback, errorCallback);
            }
    }
});