cmsApp.factory("userRolesService", function () {
    return {
        userRoles:function(){
            return  {
                ADMIN : {
                    label : 'User adminstration ',
                    desc : 'Create, edit and delete user accounts. Assign or revoke permissions. Change passwords. Suspend and activate users.',
                    selected : false,
                    selectable: true
                },
                SOURCE_EDITOR : {
                    label : 'HTML source edit',
                    desc : 'In WYSIWYG editor page fragments, this will allow the user to view and directly edit the HTML code. It should only be given to users with sufficient HTML experience.',
                    selected : false,
                    selectable: true
                },
                PUBLISHER : {
                    label : 'Publish to live',
                    desc : 'Publish new and changed content from the CMS server to the live server. This will update the live www.o2.co.uk website immediately.',
                    selected : false,
                    selectable: true
                },
                QA : {
                    label : 'Merge branches',
                    desc : 'Perform QA checks on the work done on branches to add or edit page content. When all the work has been checked and is valid, this merges the work branch into the master branch, ready for publishing to live. <br/> This does not allow publishing to the live www.o2.co.uk website.',
                    selected : false,
                    selectable: true
                },
                SYSTEM_ADMIN : {
                    label : 'System admin',
                    desc : 'This allows the publish to live function to be turned off, for example during content freeze periods.',
                    selected : false,
                    selectable: true
                },
                GOD : {
                    label : 'Un-deletable',
                    desc : 'This user is an un-deletable super user.  It should never be used except when first setting up CMS.',
                    selected : false,
                    selectable: false
                },
                DELETE_RENAME_IMAGE :{
                    label : 'Delete/Rename images',
                    desc : 'This allows the user to delete or rename image assets.',
                    selected : false,
                    selectable: true
                }
            }
        },
        selectRoles : function(rolesMap, roles) {
            for(var i in roles) {
                var role = roles[i];
                if(rolesMap[role]) {
                    rolesMap[role].selected = true;
                }
            }
        },
        getSelectedRoles : function(rolesMap) {
            var selectedRoles = [];
            for(var key in rolesMap) {
                if(rolesMap[key].selected) {
                    selectedRoles.push(key);
                }
            }
            return selectedRoles;
        }
    }
});
